﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Script.Serialization;

namespace Generic_Handler_MVC
{
    /// <summary>
    /// Summary description for Handler
    /// </summary>
    public class Handler : IHttpHandler
    {
        public void ProcessRequest(HttpContext context)
        {
            string callback = context.Request.QueryString["callback"];
            int customerId = 0;
            int.TryParse(context.Request.QueryString["customerId"], out customerId);
            string json = this.GetCustomersJSON(customerId);
            if (!string.IsNullOrEmpty(callback))
            {
                json = string.Format("{0}({1});", callback, json);
            }

            context.Response.ContentType = "text/json";
            context.Response.Write(json);
        }

        private string GetCustomersJSON(int customerId)
        {
            using (CustomerEntities entities = new CustomerEntities())
            {
                var customers = from p in entities.Customers
                                where p.CustomerId == customerId || customerId == 0
                                select p;
                return (new JavaScriptSerializer().Serialize(customers.ToList()));
            }
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}